% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stan_pars.R
\name{stan_pars}
\alias{stan_pars}
\title{Return a vector of parameters}
\usage{
stan_pars(
  obs_error,
  estimate_df = TRUE,
  est_temporalRE = FALSE,
  estimate_ar = FALSE,
  fixed_intercept = FALSE,
  save_log_lik = FALSE
)
}
\arguments{
\item{obs_error}{The observation error distribution}

\item{estimate_df}{Logical indicating whether the degrees of freedom
parameter should be estimated}

\item{est_temporalRE}{Logical: estimate a random walk for the time variable?}

\item{estimate_ar}{Logical indicating whether the ar
parameter should be estimated}

\item{fixed_intercept}{Should the intercept be fixed?}

\item{save_log_lik}{Logical: should the log likelihood for each data point be
saved so that information criteria such as LOOIC or WAIC can be calculated?
Defaults to \code{FALSE} so that the size of model objects is smaller.}
}
\description{
Return a vector of parameters
}
